/****************************************************************************
 * (c) 2018 softwareentwicklung-als-prozess.de
 * Dokumentation s. Blog
 * Funktionalitaet:
 * CAN Daten empfangen
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <SPI.h>
#include "mcp_can.h"
#include "lcd.h"
#include "can_recv.h"
#include "can_recv_ids_stati.h"

// Defines -----------------------------------------------------------------
// Display
#define BLANK  (char)32 // ASCII Leerzeichen
#define EMPTY  (char)48 // ASCII 0
#define ENDE   (char)0  // Stringende

// Variablen -----------------------------------------------------------------
long unsigned int rxId;
unsigned long     rcvTime;
unsigned char     len = (unsigned char)0;
unsigned char     buf[2];
const int SPI_CS_PIN = (int)9;
char tmpstr[3] = {EMPTY,EMPTY,ENDE};
char humstr[3] = {EMPTY,EMPTY,ENDE};

MCP_CAN CAN(SPI_CS_PIN);

// Funktionen ----------------------------------------------------------------

void CAN_Startup(void)
{
  Serial.begin(115200);
  while (CAN_OK != CAN.begin(CAN_250KBPS)) // initialisiere can bus
  {
    LCD_ShowStatus((char)STAT_TRANSCEIVER_CAN_FAILED);
    Serial.println("CAN BUS Module Initialisierungsfehler");
    Serial.println("Neuer Versuch ....");
    delay(20000);
  }    
  LCD_ShowStatus((char)STAT_DISPLAY_CANOK);
  Serial.println("CAN BUS Module Initialisiert!");
  Serial.println("Time\t\tPGN\t\tByte0\tByte1\tByte2\tByte3\tByte4\tByte5\tByte6\tByte7");   
}

void CAN_Receive(void)
{
  if(CAN_MSGAVAIL == CAN.checkReceive())
  {
    rcvTime = millis();
    CAN.readMsgBuf(&len, buf);    // Daten einlesen,  len: anzahl datenbytes, buf: Datenpuffer
    rxId = CAN.getCanId();

    Serial.print(rcvTime);
    Serial.print("\t\t");
    Serial.print("0x");
    Serial.print(rxId, HEX);
    Serial.print("\t");

    for(int i = 0; i < len; i++)    // Daten ausgeben
    {
      if(buf[i] > 15)
      {
        Serial.print("0x");
        Serial.print(buf[i], HEX);    
      }
      else
      {
        Serial.print("0x0");
        Serial.print(buf[i], HEX);
      }  
      Serial.print("\t");            
    }
    Serial.println();
    if ( rxId == ID_STATUS )
    {
      LCD_ShowStatus(buf[0]);  
    }
  }
}

