/****************************************************************************
 * (c) 2018 softwareentwicklung-als-prozess.de
 * Dokumentation s. Blog
 * Funktionalitaet:
 * Messwerte auf LCD Display ausgeben
 ***************************************************************************/
// Includes -----------------------------------------------------------------
#include <Wire.h>
#include <LiquidCrystal_I2C.h>

#include "lcd.h"
#include "can_recv_ids_stati.h"

// Variablen -----------------------------------------------------------------
LiquidCrystal_I2C lcd(0x27, 2, 1, 0, 4, 5, 6, 7, 3, POSITIVE);

// Funktionen ----------------------------------------------------------------
void LCD_Startup(void)
{
  lcd.begin(16,2);
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print(F("+    SEaP:     +"));
  lcd.setCursor(0,1);
  lcd.print(F("+ CAN Receiver +"));
  delay(2000);
}

void LCD_ShowStatus(char stat)
{
  lcd.clear();
  lcd.setCursor(0,0);
  lcd.print(F("Status:"));
  switch(stat)
  {
    case STAT_TRANSCEIVER_ETHERNET_CONNECTED:
    lcd.setCursor(8,0);
    lcd.print(F("Ethernet"));
    lcd.setCursor(0,1);
    lcd.print(F(" ist Verbunden"));
    break;
    case STAT_TRANSCEIVER_ETHERNET_FAILED:
    lcd.setCursor(8,0);
    lcd.print(F("Ethernet"));
    lcd.setCursor(0,1);
    lcd.print(F("keine Verbindung"));
    break;
    case STAT_TRANSCEIVER_MQTT_CONNECTED:
    lcd.setCursor(8,0);
    lcd.print(F("MQTT"));
    lcd.setCursor(0,1);
    lcd.print(F(" ist Verbunden"));
    break;
    case STAT_TRANSCEIVER_MQTT_FAILED:
    lcd.setCursor(8,0);
    lcd.print(F("MQTT"));
    lcd.setCursor(0,1);
    lcd.print(F("keine Verbindung"));
    break;
    case STAT_TRANSCEIVER_MQTT_RECEIVED:
    lcd.setCursor(8,0);
    lcd.print(F("MQTT"));
    lcd.setCursor(0,1);
    lcd.print(F(" Daten empfangen"));
    break;
    case STAT_TRANSCEIVER_CANOK:
    lcd.setCursor(8,0);
    lcd.print(F("CAN Bus"));
    lcd.setCursor(0,1);
    lcd.print(F(" ist Verbunden"));
    break;
    case STAT_TRANSCEIVER_CAN_FAILED:
    lcd.setCursor(8,0);
    lcd.print(F("CAN Bus"));
    lcd.setCursor(0,1);
    lcd.print(F("keine Verbindung"));
    break;
    case STAT_DISPLAY_CANOK:
    lcd.setCursor(8,0);
    lcd.print(F("Display"));
    lcd.setCursor(0,1);
    lcd.print(F(" ist Verbunden"));
    break;
    default:
    lcd.setCursor(8,0);
    lcd.print(F("Meldung"));
    lcd.setCursor(0,1);
    lcd.print(F("ist unbekannt"));
    break;
  }
}

